/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	CharBase.h													 */
/* eF		LNX `t@C								 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/04/11													 */
/* ========================================================================= */

#pragma once

class CMgrGrpData;
class CImg32;

/* ========================================================================= */
/* 萔`																	 */
/* ========================================================================= */

enum {
	CHARSTATE_IDLE = 0,							/* ҋ@ */
	CHARSTATE_MOVE_RIGHT,						/* Eֈړ */
	CHARSTATE_MOVE_LEFT,						/* ֈړ */
	CHARSTATE_DESTROY_1,						/* Œ1 */
	CHARSTATE_DESTROY_2,						/* Œ2 */
	CHARSTATE_DESTROY,							/*  */
};


/* ========================================================================= */
/* NX錾																 */
/* ========================================================================= */

typedef class CCharBase
{
public:
			CCharBase();										/* RXgN^ */
	virtual ~CCharBase();										/* fXgN^ */

	virtual void	Create		(CMgrGrpData *pMgrGrpData, int nType);	/* 쐬 */
	virtual void	Destroy		(void);									/* j */

	virtual	void	Draw		(CImg32 *pImgDst);						/* ` */
	virtual void	Proc		(void);									/*  */
	virtual void	ChgState	(int nState);							/* ԕύX */

			BOOL	IsDestroy		(void)			{ return m_bDestroy;	}	/* ł邩 */
			int		GetType			(void)			{ return m_nType;		}	/* 摜ʂ擾 */
			int		GetDirection	(void)			{ return m_nDirection;	}	/* 擾 */
			int		GetState		(void)			{ return m_nState;		}	/* Ԃ擾 */
			POINT	GetPos			(void)			{ return m_ptPos;		}	/* W擾 */
	virtual void	SetPos			(POINT ptPos)	{ m_ptPos = ptPos;		}	/* Wݒ */


protected:
	BOOL		m_bDestroy;						/* Ŕ */
	int			m_nType,						/* 摜 */
				m_nDirection,					/*  */
				m_nState;						/*  */
	POINT		m_ptPos;						/* W */

	CMgrGrpData	*m_pMgrGrpData;					/* OtBbNf[^Ǘ */
	CImg32		*m_pImg;						/* L摜 */
} CCharBase, *PCCharBase;

/* Copyright(C)URARA-works 2006 */
