/* Copyright(C)URARA-works 2005 */
/* ========================================================================= */
/* t@CF	MgrKeyInput.cpp												 */
/* eF		L[͊ǗNX t@C								 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2005/06/16													 */
/* ========================================================================= */

#include "stdafx.h"
#include "MgrKeyInput.h"


/* ========================================================================= */
/* ֐F	CMgrKeyInput::CMgrKeyInput										 */
/* eF	RXgN^													 */
/* tF	2005/06/16														 */
/* ========================================================================= */

CMgrKeyInput::CMgrKeyInput()
{
	ZeroMemory (m_abyCode,			sizeof (m_abyCode));
	ZeroMemory (m_abyKeyState,		sizeof (m_abyKeyState));
	ZeroMemory (m_abyKeyStateBack,	sizeof (m_abyKeyStateBack));
}


/* ========================================================================= */
/* ֐F	CMgrKeyInput::~CMgrKeyInput										 */
/* eF	fXgN^													 */
/* tF	2005/06/16														 */
/* ========================================================================= */

CMgrKeyInput::~CMgrKeyInput()
{
	Destroy ();
}


/* ========================================================================= */
/* ֐FCMgrKeyInput::Create												 */
/* eF쐬																 */
/* tF2005/06/16															 */
/* ========================================================================= */

void CMgrKeyInput::Create(void)
{
	ZeroMemory (m_abyCode, sizeof (m_abyCode));

	m_abyCode[0] = VK_UP;		/*  */
	m_abyCode[1] = VK_DOWN;		/*  */
	m_abyCode[2] = VK_LEFT;		/*  */
	m_abyCode[3] = VK_RIGHT;	/*  */
	m_abyCode[4] = 'X';			/* X */
	m_abyCode[5] = 'Z';			/* Z */
	m_abyCode[6] = 'S';			/* S */
	m_abyCode[7] = 'A';			/* A */
	m_abyCode[8] = VK_RETURN;	/* Enter */
}


/* ========================================================================= */
/* ֐FCMgrKeyInput::Destroy											 */
/* eFj																 */
/* tF2005/06/16															 */
/* ========================================================================= */

void CMgrKeyInput::Destroy(void)
{
}


/* ========================================================================= */
/* ֐F	CMgrKeyInput::Renew												 */
/* eF	ԍXV														 */
/* tF	2005/06/16														 */
/* ========================================================================= */

void CMgrKeyInput::Renew(BYTE &byCode, BOOL &bDown)
{
	int i;
	BYTE byCodeTmp;

	GetKeyboardState (m_abyKeyState);

	byCode	= 0;
	bDown	= FALSE;

	/* e[uɓo^ꂽ[L[̓͏ԂXV */
	for (i = 0; ; i ++) {
		byCodeTmp = m_abyCode[i];
		if (byCodeTmp == 0) {
			break;
		}
		if ((m_abyKeyState[byCodeTmp] & 0x80) && (m_abyKeyStateBack[byCodeTmp] == 0)) {
			m_abyKeyStateBack[byCodeTmp] = 1;
			byCode	= byCodeTmp;
			bDown	= TRUE;
			break;

		} else if (((m_abyKeyState[byCodeTmp] & 0x80) == 0) && (m_abyKeyStateBack[byCodeTmp] == 1)) {
			m_abyKeyStateBack[byCodeTmp] = 0;
			byCode	= byCodeTmp;
			bDown	= FALSE;
			break;
		}
	}
}


/* ========================================================================= */
/* ֐F	CMgrKeyInput::Reset												 */
/* eF																 */
/* tF	2005/08/09														 */
/* ========================================================================= */

void CMgrKeyInput::Reset(void)
{
	ZeroMemory (m_abyKeyState,		sizeof (m_abyKeyState));
	ZeroMemory (m_abyKeyStateBack,	sizeof (m_abyKeyStateBack));
}


/* ========================================================================= */
/* ֐F	CMgrKeyInput::IsInput											 */
/* eF															 */
/* tF	2005/08/05														 */
/* ========================================================================= */

BOOL CMgrKeyInput::IsInput(BYTE byCode)
{
	BOOL bRet;

	bRet = FALSE;

	if ((m_abyKeyState[byCode] & 0x80) == 0) {
		goto Exit;
	}

	bRet = TRUE;
Exit:
	return bRet;
}

/* Copyright(C)URARA-works 2005 */
