/* Copyright(C)URARA-works 2005 */
/* ========================================================================= */
/* t@CF	Img32.h														 */
/* eF		32bitC[WNX `t@C							 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2005/01/24													 */
/* ========================================================================= */

#pragma once

/* ========================================================================= */
/* NX錾																 */
/* ========================================================================= */

typedef class CImg32
{
public:
			CImg32(void);										/* RXgN^ */
	virtual ~CImg32();											/* fXgN^ */

	BOOL	Create				(int cx, int cy);										/* rbg}bv쐬 */
	BOOL	CreateWithoutGdi	(int cx, int cy, LPBYTE pBits = NULL);					/* GDI݊ō쐬 */
	void	Destroy				(void);													/* j */

	void	Clear				(void);													/* NA */
	void	FillRect			(int x, int y, int cx, int cy, COLORREF clFill);		/* `hԂ */
	void	ChgLevel			(int x, int y, int cx, int cy, BYTE byLevel);			/* xύX */
	void	ChgColor			(int x, int y, int cx, int cy, COLORREF clChg);			/* FfύX */

	void	Blt					(int dx, int dy, int cx, int cy, CImg32 *pSrc, int sx, int sy, BOOL bColorKey = FALSE);						/* `] */
	void	BltLevel			(int dx, int dy, int cx, int cy, CImg32 *pSrc, int sx, int sy, BYTE byLevel, BOOL bColorKey = FALSE);		/* xςȂ`] */
	void	BltAlpha			(int dx, int dy, int cx, int cy, CImg32 *pSrc, int sx, int sy, BYTE byLevel, BOOL bColorKey = FALSE);		/* 킹`] */
	void	BltAlpha2			(int dx, int dy, int cx, int cy, CImg32 *pSrc, int sx, int sy, BYTE byLevelAlpha, BOOL bColorKey = FALSE);	/* J[L[̂ݍ킹`] */
	void	BltTurnRightAndLeft	(int dx, int dy, int cx, int cy, CImg32 *pSrc, int sx, int sy, BOOL bColorKey = FALSE);						/* E]ċ`] */
	void	BltTurnUpAndDown(int dx, int dy, int cx, int cy, CImg32 *pSrc, int sx, int sy, BOOL bColorKey = FALSE);							/* ㉺]ċ`] */	

	HDC		Lock				(void);									/* 摜bN */
	void	Unlock				(void);									/* bN */

	HBITMAP	GetSafeHandle		(void);									/* rbg}bvnh擾 */
	int		Width				(void);									/* 擾 */
	int		Height				(void);									/* 擾 */
	int		GetImageSize		(void);									/* f[^TCY擾 */
	LPBYTE	GetBits				(void);									/* rbgf[^̃AhX擾 */
	void	SetColorKey			(COLORREF clKey);						/* J[L[ݒ */
	COLORREF GetColorKey		(void);									/* J[L[擾 */


protected:
	void	InitData			(void);									/* f[^ */
	DWORD	ColorrefToDword		(COLORREF cl);							/* FfDWORDlɕϊ */
	BYTE	PercentToHex		(BYTE byPercent);						/* p[Zg255MAX16iɕϊ */
	void	ClipPos				(int &dx, int &dy, int &cx, int &cy, CImg32 *pSrc, int &sx, int &sy);	/* WNbsO */


protected:
	HBITMAP			m_hBmp;								/* rbg}bvnh */
	HBITMAP			m_hBmpBack;							/* rbg}bvnhۑp */
	BITMAPINFO		m_bmpInfo;							/* rbg}bv */
	LPBYTE			m_pBits;							/* rbgf[^ */
	HDC				m_hDC;								/* foCXReLXgnh */
	DWORD			m_dwColorKey;						/* J[L[ */
} CImg32, *PCImg32;

/* Copyright(C)URARA-works 2005 */
