/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	CharSONSON.cpp												 */
/* eF		LNX(\\) t@C							 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/04/23													 */
/* ========================================================================= */

#include "stdafx.h"
#include "../MgrGrpData.h"
#include "../lib/Img32.h"
#include "CharSONSON.h"


/* ========================================================================= */
/* ֐F	CCharSONSON::CCharSONSON										 */
/* eF	RXgN^													 */
/* tF	2006/04/11														 */
/* ========================================================================= */

CCharSONSON::CCharSONSON()
{
	m_nAnime				= 0;
	m_dwTimeLastProcAnime	= 0;
	m_dwTimeLastProcMove	= 0;

	m_ptPos.y = 180;
}


/* ========================================================================= */
/* ֐F	CCharSONSON::~CCharSONSON										 */
/* eF	fXgN^													 */
/* tF	2006/04/11														 */
/* ========================================================================= */

CCharSONSON::~CCharSONSON()
{
}


/* ========================================================================= */
/* ֐F	CCharSONSON::Create												 */
/* eF	쐬															 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CCharSONSON::Create(CMgrGrpData *pMgrGrpData, int nType)
{
	PCImg32 pImgTmp;

	CCharBase::Create (pMgrGrpData, nType);

	pImgTmp = m_pMgrGrpData->GetDibPlayer ();

	m_pImg = new CImg32;
	m_pImg->CreateWithoutGdi (192 * 2, 16 * 2);
	m_pImg->SetColorKey (RGB (255, 0, 255));

	/* Kvȕ摜Rs[ */
	m_pImg->Blt (0, 0, 192 * 2, 16 * 2, pImgTmp, 0, m_nType * 32);
}


/* ========================================================================= */
/* ֐F	CCharSONSON::Draw												 */
/* eF	`															 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CCharSONSON::Draw(CImg32 *pImgDst)
{
	pImgDst->Blt (
			m_ptPos.x,
			m_ptPos.y,
			32, 32, m_pImg,
			(m_nDirection * 64) + (m_nAnime * 32),
			0,
			TRUE);
}


/* ========================================================================= */
/* ֐F	CCharSONSON::Proc												 */
/* eF																 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CCharSONSON::Proc(void)
{
	DWORD dwTmp, dwTime;

	dwTime = timeGetTime ();

	dwTmp = dwTime - m_dwTimeLastProcMove;
	if (dwTmp < 40) {
		goto Exit;
	}
	if (m_dwTimeLastProcMove == 0) {
		m_dwTimeLastProcMove = dwTime;
		goto Exit;
	}

	/* 40~b1t[ */
	dwTmp /= 40;

	m_dwTimeLastProcMove = dwTime;

	switch (m_nState) {
	case CHARSTATE_IDLE:		ProcMOVE_IDLE	(dwTmp);	break;	/* ҋ@ */
	case CHARSTATE_MOVE_RIGHT:	ProcMOVE_RIGHT	(dwTmp);	break;	/* Eֈړ */
	case CHARSTATE_MOVE_LEFT:	ProcMOVE_LEFT	(dwTmp);	break;	/* ֈړ */
		break;
	}

Exit:
	return;
}


/* ========================================================================= */
/* ֐F	CCharSONSON::UpdateAnimeMOVE									 */
/* eF	ړ̃Aj[VXV										 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharSONSON::UpdateAnimeMOVE(DWORD dwTime)
{
	if (dwTime - m_dwTimeLastProcAnime < 90) {
		return;
	}

	/* Aj[VXV */
	m_dwTimeLastProcAnime = dwTime;
	m_nAnime = 1 - m_nAnime;
}


/* ========================================================================= */
/* ֐F	CCharSONSON::ProcMOVE_IDLE										 */
/* eF	(ҋ@)													 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharSONSON::ProcMOVE_IDLE(DWORD dwTime)
{
	UpdateAnimeMOVE (timeGetTime ());
}


/* ========================================================================= */
/* ֐F	CCharSONSON::ProcMOVE_RIGHT										 */
/* eF	(Eֈړ)												 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharSONSON::ProcMOVE_RIGHT(DWORD dwTime)
{
	m_nDirection = 0;
	m_ptPos.x += (dwTime * 4);
	m_ptPos.x = min (m_ptPos.x, 480);

	UpdateAnimeMOVE (timeGetTime ());
}


/* ========================================================================= */
/* ֐F	CCharSONSON::ProcMOVE_LEFT										 */
/* eF	(ֈړ)												 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharSONSON::ProcMOVE_LEFT(DWORD dwTime)
{
	m_nDirection = 1;
	m_ptPos.x -= (dwTime * 4);
	m_ptPos.x = max (m_ptPos.x, 0);

	UpdateAnimeMOVE (timeGetTime ());
}

/* Copyright(C)URARA-works 2006 */
